//==================================================================
//
//  Generic Header information generated by 13504CFG.EXE (Build 2)
//
//  Copyright (c) 2000,2001 Epson Research and Development, Inc.
//  All rights reserved.
//
//  CRT: 640x480x8bpp 60Hz Color 16-Bit STN (PCLK=25.175MHz)
//
//  This file defines the configuration environment and registers,
//  which can be used by any software, such as display drivers.
//
//  PLEASE NOTE: If you FTP this file to a non-Windows platform, make
//               sure you transfer this file using ASCII, not BINARY
//               mode.
//
//==================================================================

#define S1D_DISPLAY_WIDTH               640
#define S1D_DISPLAY_HEIGHT              480
#define S1D_DISPLAY_BPP                 8
#define S1D_DISPLAY_SCANLINE_BYTES      640
#define S1D_DISPLAY_FRAME_RATE          60
#define S1D_DISPLAY_PCLK                25175000L
#define S1D_PHYSICAL_REG_ADDR           0x000DFFE0L
#define S1D_PHYSICAL_VMEM_ADDR          0x000D0000L
#define S1D_PHYSICAL_REG_SIZE           47L
#define S1D_PHYSICAL_VMEM_SIZE          2097152L
#define S1D_PALETTE_SIZE                16
#define S1D_FRAME_RATE                  60
#define S1D_POWER_DELAY_OFF             500
#define S1D_POWER_DELAY_ON              0

#define S1D_WRITE_PALETTE(p,i,r,g,b)  \
  {  \
  ((volatile S1D_VALUE*)(p))[0x24/sizeof(S1D_VALUE)] = (S1D_VALUE)(i); \
  ((volatile S1D_VALUE*)(p))[0x26/sizeof(S1D_VALUE)] = (S1D_VALUE)((r)>>4); \
  ((volatile S1D_VALUE*)(p))[0x26/sizeof(S1D_VALUE)] = (S1D_VALUE)((g)>>4); \
  ((volatile S1D_VALUE*)(p))[0x26/sizeof(S1D_VALUE)] = (S1D_VALUE)((b)>>4); \
  }

#define S1D_READ_PALETTE(p,i,r,g,b)   \
  {  \
  ((volatile S1D_VALUE*)(p))[0x24/sizeof(S1D_VALUE)] = (S1D_VALUE)(i); \
  r = ((volatile S1D_VALUE*)(p))[0x26/sizeof(S1D_VALUE)]; \
  r <<= 4; \
  g = ((volatile S1D_VALUE*)(p))[0x26/sizeof(S1D_VALUE)]; \
  g <<= 4; \
  b = ((volatile S1D_VALUE*)(p))[0x26/sizeof(S1D_VALUE)]; \
  b <<= 4; \
  }

typedef unsigned char S1D_INDEX;
typedef unsigned long S1D_VALUE;
typedef struct
{
    S1D_INDEX Index;
    S1D_VALUE Value;
} S1D_REGS;

static S1D_REGS aS1DRegs[] =
{
    { 0x00,             0x00000000 },       // Revision Code Register
    { 0x01,             0x00000050 },       // Memory Configuration Register
    { 0x02,             0x00000024 },       // Panel Type Register
    { 0x03,             0x00000000 },       // MOD Rate Register
    { 0x04,             0x0000004F },       // Horizontal Display Width Register
    { 0x05,             0x00000013 },       // Horizontal Non-Display Period Register
    { 0x06,             0x00000001 },       // HRTC/FPLINE Start Position Register
    { 0x07,             0x0000000B },       // HRTC/FPLINE Pulse Width Register
    { 0x08,             0x000000DF },       // Vertical Display Height Register 0
    { 0x09,             0x00000001 },       // Vertical Display Height Register 1
    { 0x0A,             0x0000002B },       // Vertical Non-Display Period Register
    { 0x0B,             0x00000009 },       // VRTC/FPFRAME Start Position Register
    { 0x0C,             0x00000001 },       // VRTC/FPFRAME Pulse Width Register
    { 0x0D,             0x0000000E },       // Display Mode Register
    { 0x0E,             0x000000FF },       // Screen 1 Line Compare Register 0
    { 0x0F,             0x00000003 },       // Screen 1 Line Compare Register 1
    { 0x10,             0x00000000 },       // Screen 1 Display Start Address Register 0
    { 0x11,             0x00000000 },       // Screen 1 Display Start Address Register 1
    { 0x12,             0x00000000 },       // Screen 1 Display Start Address Register 2
    { 0x13,             0x00000000 },       // Screen 2 Display Start Address Register 0
    { 0x14,             0x00000000 },       // Screen 2 Display Start Address Register 1
    { 0x15,             0x00000000 },       // Screen 2 Display Start Address Register 2
    { 0x16,             0x00000040 },       // Memory Address Offset Register 0
    { 0x17,             0x00000001 },       // Memory Address Offset Register 1
    { 0x18,             0x00000000 },       // Pixel Panning Register
    { 0x19,             0x00000000 },       // Clock Configuration Register
    { 0x1A,             0x00000000 },       // Power Save Configuration Register
    { 0x1B,             0x00000000 },       // Miscellaneous Disable Register
    { 0x1C,             0x00000000 },       // MD Configuration Readback Register 0
    { 0x1D,             0x00000000 },       // MD Configuration Readback Register 1
    { 0x1E,             0x00000000 },       // GPIO Configuration Register 0
    { 0x1F,             0x00000000 },       // GPIO Configuration Register 1
    { 0x20,             0x00000000 },       // GPIO Status / Control Register 0
    { 0x21,             0x00000000 },       // GPIO Status / Control Register 1
    { 0x22,             0x00000058 },       // Performance Enhancement Register 0
    { 0x23,             0x00000010 },       // Performance Enhancement Register 1
    { 0x24,             0x00000000 },       // Look-Up Table Address Register
    { 0x25,             0x00000000 },       // Not Used
    { 0x26,             0x00000000 },       // Look-Up Table Data Register
    { 0x27,             0x00000000 },       // Look-Up Table Bank Select Register
    { 0x28,             0x00000000 },       // RAMDAC Pixel Read Mask Register
    { 0x29,             0x00000000 },       // RAMDAC Pixel Read Mask Register
    { 0x2A,             0x00000000 },       // RAMDAC Read Mode Address Register
    { 0x2B,             0x00000000 },       // RAMDAC Read Mode Address Register
    { 0x2C,             0x00000000 },       // RAMDAC Write Mode Address Register
    { 0x2D,             0x00000000 },       // RAMDAC Write Mode Address Register
    { 0x2E,             0x00000000 },       // RAMDAC Palette Data Register
    { 0x2F,             0x00000000 },       // RAMDAC Palette Data Register
};
